package com.alterdekim.hearthhack.component.processor;

import com.alterdekim.Protocol;
import com.alterdekim.hearthhack.component.TcpConnection;
import com.alterdekim.hearthhack.util.BattleNetPacket;
import com.alterdekim.hearthhack.util.Compute32;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@NoArgsConstructor
public abstract class Processor {

    @Setter
    private int processorId;

    public int getProcessorHash() { return Compute32.Hash(getExportName()); }

    public String getExportName() {
        return "";
    }

    public abstract void process(BattleNetPacket packet, TcpConnection conn) throws Exception;

    public static Protocol.Header generateResponse(int size, int token) {
        return Protocol.Header.newBuilder()
                .setServiceId(254)
                .setSize(size)
                .setToken(token)
                .build();
    }

    public static Protocol.Header generateResponse(int size, int token, int status, int object_id) {
        return Protocol.Header.newBuilder()
                .setServiceId(254)
                .setSize(size)
                .setStatus(status)
                .setToken(token)
                .setObjectId(object_id)
                .build();
    }

    public static Protocol.Header generateResponse(int size, int token, int object_id) {
        return Protocol.Header.newBuilder()
                .setServiceId(254)
                .setSize(size)
                .setToken(token)
                .setObjectId(object_id)
                .build();
    }
}
